using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;

namespace Tierra 
{
    
    /// <summary>
    /// [TierraIy[VVXe]
    /// [Tv] TierraɊւ鏈sNX
    /// </summary>
    class TierraOS 
    {
        private const int SOUP_SIZE = 30000;            //X[vTCY
        private const int TEMPLATE_SIZE = 4;            //ev[gTCY
        private const int SHORTEST_CELL_SIZE = 10;            //Cell̍ŏTCY
        private const double REAPER_RATE = 0.80;           //Cell̏soup̊Asoup̊ȏɖ܂ĂꍇACell
        private const double SOUP_MUTATE_RATE = 0.001;      //soupS̓ˑRψيm
        private const double COPY_MUTATE_RATE = 0.0001;      //Rs[ˑRψيm
        private int sliceSize = 10;                      //XCXTCYiPtimeSlice()̎sŉcodes邩j

        private int[] soup = new int[SOUP_SIZE];        //X[v
        private int[] authSoup = new int[SOUP_SIZE];    //L}XpX[v
        private int cpuIndex = 1;                     //cpuʂׂ̔ԍ

        private List<Cpu> cpuGroup = new List<Cpu>();   //cpuO[vACellcpu̔z
        private List<Cpu> newCpuAry = new List<Cpu>();  //VKɒǉCpuQ
        private LinkedList<Cpu> reaperQueue = new LinkedList<Cpu>();//_L[A1^[ɊeCell͂̒l̃R[hs

        public bool isDrawCode = false; //X[v̊eR[h̕`邩ۂ
        public bool isDrawCell = true; //eCell̕`邩ۂ
        private Random random = new Random(Environment.TickCount);
        private int turn;                               //^[JE^



        //RXgN^
        //Cell̐ݒȂ
        public TierraOS() 
        {
            //soup̏
            for(int i = 0; i < SOUP_SIZE; i++) 
            {
                this.soup[i] = -1;
                this.authSoup[i] = 0;
            }

            //cCell̐ݒ
            int[] orgCell = { 1, 1, 1, 1, 4, 2, 3, 3, 24, 28, 0, 0, 0, 0, 7, 25, 29, 0, 0, 0, 1, 8, 6, 1, 1, 0, 1, 30, 22, 0, 0, 1, 1, 31, 20, 0, 0, 1, 0, 5, 1, 1, 0, 0, 12, 13, 14, 1, 0, 1, 0, 26, 11, 5, 20, 0, 1, 0, 0, 8, 9, 20, 0, 1, 0, 1, 5, 1, 0, 1, 1, 18, 17, 16, 23, 1, 1, 1, 0, 5 };
            int ip = 0; //(int) (SOUP_SIZE / 2);
            for(int i = 0; i < orgCell.Length; i++) 
            {
               soup[regSoupAdr(ip + i)] = orgCell[i];
            }
            makeCell(ip, orgCell.Length,0);
            Cpu cpu = newCpuAry[0];
            cpu.recordIndex = CellRecord.registCell(cpu, soup);
            cpu.isRecord = true;
        }

        //C
        // 1^[̏
        public void mainExe() 
        {
            this.turn++;
            //Console.Write("- turn : " + this.turn + " -");

            //ˑRψ
            soupMutation();

            //ecpu(Cell)s
            foreach (Cpu cpu in this.cpuGroup) 
            {
                timeSlice(cpu);
            }
            //VK쐬ꂽcpucpuGroupɒǉ
            foreach (Cpu cpu in this.newCpuAry) 
            {
                this.cpuGroup.Add(cpu);
            }
            this.newCpuAry.Clear();

            //_
            reaper();
        }

        //Cell(Cpu)VKo^
        private void makeCell(int ip, int len,int rcdIdx) 
        {
            Cpu cpu = new Cpu(cpuIndex, ip); //CellpCpu̐߃|C^̐ݒ
            cpuIndex++;
            cpu.length = len;
            cpu.head = ip;
            //̈̌̐ݒ
            for(int i = 0; i < cpu.length; i++) 
            {
                authSoup[regSoupAdr(cpu.head + i)] = cpu.index;
            }
            this.newCpuAry.Add(cpu);
            this.reaperQueue.AddLast(cpu);
            cpu.recordIndex = rcdIdx;
        }

        //_
        private void reaper() 
        {
 //           bool flag=true;
            {
                //soupcode̐Lʂ𑪂
                int codeNum = 0;
                foreach(int code in this.soup) 
                {
                    if(code != -1) codeNum++;
                }
                //code̐LʂKl𒴂ĂꍇA_
                if(((double) codeNum / SOUP_SIZE) > REAPER_RATE) 
                {
                    Cpu cpu = this.reaperQueue.First.Value;
                    this.reaperQueue.RemoveFirst();
                    this.cpuGroup.Remove(cpu);
                    for(int i = 0; i < cpu.length; i++) //cpȕꏊƂƂɂƂ
                    {
                        this.soup[regSoupAdr(cpu.head + i)] = -1;
                        this.authSoup[regSoupAdr(cpu.head + i)] = 0;
                    }
                    if(cpu.newHead != -1) 
                    {
                        for(int i = 0; i < cpu.newLength; i++) 
                        {
                            this.soup[regSoupAdr(cpu.newHead + i)] = -1;
                            this.authSoup[regSoupAdr(cpu.newHead + i)] = 0;
                        }
                    }
                }
 //               else 
 //                   flag=false;
            }
        }

        //ˑRψفiSsoupɑ΂ψفj
        private void soupMutation() 
        {
            if(random.NextDouble() < SOUP_MUTATE_RATE) 
            {
                int randIp = random.Next(SOUP_SIZE);
                int code = this.soup[randIp];
                if(code < 0x00 || code > 0x1f) return;
                int mutateCode = (int)Math.Pow(2,random.Next(5));
                //TierraLog.write("turn:" + this.turn + " [soupMutation] beforCode: " + Convert.ToString(code, 2) + ", mutateCode: " + Convert.ToString(mutateCode, 2));
                code = code ^ mutateCode;
                //TierraLog.writeLine(", afterCode: " + Convert.ToString(code, 2));
                this.soup[randIp] = code;
            }
        }

        //ˑRψفiRs[̕ψفj
        private void copyMutation(ref int code) 
        {
            if(random.NextDouble() < COPY_MUTATE_RATE) 
            {
                int randIp = random.Next(SOUP_SIZE);
                int mutateCode = (int) Math.Pow(2, random.Next(5));
                //TierraLog.write("turn:" + this.turn + " [copyMutation] beforCode: " + Convert.ToString(code, 2) + ", mutateCode: " + Convert.ToString(mutateCode, 2));
                code = code ^ mutateCode;
                //TierraLog.writeLine(", afterCode: " + Convert.ToString(code, 2));
            }

        }

        //^CXCX
        // sliceSize̒lAwcpu(Cell)̃R[hs
        private void timeSlice(Cpu cpu) 
        {
            for (int i = 0; i < this.sliceSize; i++) 
            {
                //Console.Write(" [ " + i + " ]");

                int code = fetch(cpu);   //߂̃tFb`
                //Console.Write(" code : " + getCodeName(code)+"["+code+"]");
                ;                           //߂̃fR[h(svȂ̂Ŗ)
                execute(code, cpu);         //߂̎s
                incrementIp(code, cpu);     //ip̃CNg
                systemWork(cpu);            //VXȅ
                //Console.WriteLine();
            }
        }

        

        //߂̃tFb`
        // X[vwʒũR[ho
        // G[ɂ-1Ԃ
        private int fetch(Cpu cpu) 
        {
            if(cpu.ip < 0 || cpu.ip >= SOUP_SIZE) return -1; //soup̗̈𒴂ĂȂ
            else if(!canSightLength(cpu, cpu.ip)) return -1; //ǂݍ݉\ȋ
            else return this.soup[cpu.ip];
        }

        //߂̎s
        // w(code)̖߂sAcpȕA܂soupύX
        private void execute(int code, Cpu cpu) 
        {
            switch (code) 
            {
                case 0x00: nop_0(cpu); break;
                case 0x01: nop_1(cpu); break;
                case 0x02: not0(cpu); break;
                case 0x03: sh1(cpu); break;
                case 0x04: zero(cpu); break;
                case 0x05: if_cz(cpu); break;
                case 0x06: sub_ab(cpu); break;
                case 0x07: sub_ac(cpu); break;
                case 0x08: inc_a(cpu); break;
                case 0x09: inc_b(cpu); break;
                case 0x0a: inc_c(cpu); break;
                case 0x0b: dec_c(cpu); break;
                case 0x0c: push_ax(cpu); break;
                case 0x0d: push_bx(cpu); break;
                case 0x0e: push_cx(cpu); break;
                case 0x0f: push_dx(cpu); break;
                case 0x10: pop_ax(cpu); break;
                case 0x11: pop_bx(cpu); break;
                case 0x12: pop_cx(cpu); break;
                case 0x13: pop_dx(cpu); break;
                case 0x14: jmp(cpu); break;
                case 0x15: jmpb(cpu); break;
                case 0x16: call(cpu); break;
                case 0x17: ret(cpu); break;
                case 0x18: mov_cd(cpu); break;
                case 0x19: mov_ab(cpu); break;
                case 0x1a: mov_abi(cpu); break;
                case 0x1b: adr(cpu); break;
                case 0x1c: adrb(cpu); break;
                case 0x1d: adrf(cpu); break;
                case 0x1e: mal(cpu); break;
                case 0x1f: divide(cpu); break;
                default: cpu.flag = true; break;
            }
        }

        //ip̃CNg
        private void incrementIp(int code, Cpu cpu) 
        {
            cpu.ip++; cpu.ip = regSoupAdr(cpu.ip);
        }

        //VXe
        private void systemWork(Cpu cpu) 
        {

            //_L[̒ړ
            LinkedListNode<Cpu> thisNode = this.reaperQueue.Find(cpu);
            if(cpu.flag) {  //ɋߕt
                if(!thisNode.Equals(this.reaperQueue.First)) 
                {
                    LinkedListNode<Cpu> previousNode = thisNode.Previous;
                    this.reaperQueue.Remove(thisNode);
                    this.reaperQueue.AddBefore(previousNode, cpu);
                }
                cpu.flag = false;
            } else {  //痣
                if(!thisNode.Equals(this.reaperQueue.Last)) 
                {
                    LinkedListNode<Cpu> nextNode = thisNode.Next;
                    this.reaperQueue.Remove(thisNode);
                    this.reaperQueue.AddAfter(nextNode, cpu);
                }
            }

            /*
            Cpu cpu = cpuGroup[0];
            Console.Write(" \t| ax:" + cpu.ax + ", bx:" + cpu.bx + ", cx:" + cpu.cx + ", dx:" + cpu.dx);
            Console.Write(" \t| flag:" + cpu.flag + ", ip:" + cpu.ip + ", sp:" + cpu.sp);
            int[] st = cpu.stack;
            Console.Write(" \t| stack:" + st[0] + ", " + st[1] + ", " + st[2] + ", " + st[3] + ", " + st[4] + ", " + st[5] + ", " + st[6]);
            Console.Write(" \t| newHead:" + cpu.newHead + ", length:" + cpu.length);
            */
        }

        //
        //@wAhXAwCell(Cpu)猩邩𔻒肷
        private bool canSightLength(Cpu cpu,int adr) 
        {
            int sightLength = cpu.length * 5;
            if(regSoupAdr(cpu.head - adr) < sightLength || regSoupAdr(adr - cpu.head + cpu.length) < sightLength) return true;
            else return false;
        }


        //߃R[hsp֐Q
        public void nop_0(Cpu cpu) { }
        public void nop_1(Cpu cpu) { }
        public void not0(Cpu cpu) { cpu.cx ^= 1; }   //cx̍ŉʃrbg𔽓]
        public void sh1(Cpu cpu) { cpu.cx <<= 1; }   //cx1Vtg
        public void zero(Cpu cpu) { cpu.cx = 0; }    //cx0
        public void if_cz(Cpu cpu) { if (cpu.cx != 0)cpu.ip++; }   //cx!=0Ȃ玟̖߂̓pX
        public void sub_ab(Cpu cpu) { cpu.cx = cpu.ax - cpu.bx; if(cpu.cx < 0) { cpu.cx = 0; cpu.flag = true; } }   //cxaxbxŌZʂ
        public void sub_ac(Cpu cpu) { cpu.ax = cpu.ax - cpu.cx; if(cpu.ax < 0) { cpu.ax = 0; cpu.flag = true; } }   //axaxcxŌZʂ
        public void inc_a(Cpu cpu) { cpu.ax++; }   //ax̃CNg
        public void inc_b(Cpu cpu) { cpu.bx++; }   //bx̃CNg
        public void inc_c(Cpu cpu) { cpu.cx++; }   //cx̃CNg
        public void dec_c(Cpu cpu) { cpu.cx--; if(cpu.cx < 0) { cpu.cx = 0; cpu.flag = true; } }   //cx̃fNg
        public void push_ax(Cpu cpu) { int res = push(cpu.stack, ref cpu.sp, cpu.ax); if(res == -1)cpu.flag = true; }   //axX^bNPUSH
        public void push_bx(Cpu cpu) { int res = push(cpu.stack, ref cpu.sp, cpu.bx); if(res == -1)cpu.flag = true; }   //bxX^bNPUSH
        public void push_cx(Cpu cpu) { int res = push(cpu.stack, ref cpu.sp, cpu.cx); if(res == -1)cpu.flag = true; }   //cxX^bNPUSH
        public void push_dx(Cpu cpu) { int res = push(cpu.stack, ref cpu.sp, cpu.dx); if(res == -1)cpu.flag = true; }   //dxX^bNPUSH
        public void pop_ax(Cpu cpu) { int res = pop(cpu.stack, ref cpu.sp); if(res != -1)cpu.ax = res; else cpu.flag = true; }//X^bNaxPOP
        public void pop_bx(Cpu cpu) { int res = pop(cpu.stack, ref cpu.sp); if(res != -1)cpu.bx = res; else cpu.flag = true; }//X^bNbxPOP
        public void pop_cx(Cpu cpu) { int res = pop(cpu.stack, ref cpu.sp); if(res != -1)cpu.cx = res; else cpu.flag = true; }//X^bNcxPOP
        public void pop_dx(Cpu cpu) { int res = pop(cpu.stack, ref cpu.sp); if(res != -1)cpu.dx = res; else cpu.flag = true; }//X^bNdxPOP
        public void jmp(Cpu cpu) 
        {  //ŋ߂̑ev[gփWv
            int[] tmpl = getArrayRange(soup, cpu.ip + 1, TEMPLATE_SIZE);
            int nearAdr;
            int adr1 = find_adr(cpu.ip, soup, tmpl, 1);     //OT
            int adr2 = find_adr(cpu.ip, soup, tmpl, -1);    //T
            if(adr1 == -1)cpu.flag = true;                  //ȂꍇAG[tO𗧂ĂĖ߂
            else 
            {                                               //ꍇA߂̃AhXݒ肷
                if(regSoupAdr(adr1 - cpu.ip) > regSoupAdr(cpu.ip - adr2)) nearAdr = adr2;
                else nearAdr = adr1;
                if(canSightLength(cpu, nearAdr)) cpu.ip = nearAdr;
                else { cpu.flag = true; return; }
            }
        }
        public void jmpb(Cpu cpu) 
        {  //̑ev[gփWv
            int[] tmpl = getArrayRange(soup, cpu.ip + 1, TEMPLATE_SIZE);
            int adr = find_adr(cpu.ip, soup, tmpl, -1);
            if(adr != -1 && canSightLength(cpu, adr)) cpu.ip = adr; else cpu.flag = true;
        }
        public void mov_cd(Cpu cpu) { cpu.dx = cpu.cx; }  //cx̒ldxɑ
        public void mov_ab(Cpu cpu) { cpu.bx = cpu.ax; }  //ax̒lbxɑ
        public void mov_abi(Cpu cpu) {                    //bxAhX̒laxAhX
            //l̃Rs[
            //@}X}Xɂ߂Ȃ
            if(soup[regSoupAdr(cpu.ax)] == -1 || authSoup[regSoupAdr(cpu.ax)] == cpu.index) 
            {
                soup[regSoupAdr(cpu.ax)] = soup[regSoupAdr(cpu.bx)]; //Rs[s
                copyMutation(ref soup[regSoupAdr(cpu.ax)]);          //Rs[̓ˑRψ
            } else cpu.flag = true;
        }

        public void adr(Cpu cpu) { //ŋ߂̑ev[g̃AhXax
            int[] tmpl = getArrayRange(soup, cpu.ip + 1, TEMPLATE_SIZE);
            int nearAdr;
            int adr1 = find_adr(cpu.ip, soup, tmpl, 1) + 1;     //OT
            int adr2 = find_adr(cpu.ip, soup, tmpl, -1) + 1;    //T
            if(adr1 == -1) cpu.flag = true;                     //ȂꍇAG[tO𗧂ĂĖ߂
            else {                                              //ꍇA߂̃AhXݒ肷
                if(regSoupAdr(adr1 - cpu.ip) > regSoupAdr(cpu.ip - adr2)) nearAdr = adr2;
                else nearAdr = adr1;
                if(canSightLength(cpu, nearAdr)) cpu.ax = nearAdr;
                else { cpu.flag = true; return; }
            }
        }
        public void adrb(Cpu cpu) {  //̑ev[g̃AhXax
            int[] tmpl = getArrayRange(soup, cpu.ip + 1, TEMPLATE_SIZE);
            int adr = find_adr(cpu.ip, soup, tmpl, -1) + 1;
            if(adr != -1 && canSightLength(cpu, adr)) cpu.ax = adr; else cpu.flag = true;
        }
        public void adrf(Cpu cpu) {  //Ȏev[g̃AhXax
            int[] tmpl = getArrayRange(soup, cpu.ip + 1, TEMPLATE_SIZE);
            int adr = find_adr(cpu.ip, soup, tmpl, 1) + 1;
            if(adr != -1 && canSightLength(cpu, adr)) cpu.ax = adr; else cpu.flag = true;
        }
        public void call(Cpu cpu) {  //ev[g̃AhXcall
            int res = push(cpu.stack, ref cpu.sp, cpu.ip);
            if(res != -1) jmp(cpu); else cpu.flag = true;
        }
        public void ret(Cpu cpu) {   //X^bNJڐAhXPOP
            int res = pop(cpu.stack, ref cpu.sp);
            if(res != -1) cpu.ip = res; else cpu.flag = true;
        }
        //Cellׂ̈̃m
        //@mۂ̈̐擪AhXax,newHeadɁAŌAhXnewTailɓ
        //@ȂAmۂ̈TCYcx̒lp
        public void mal(Cpu cpu) {
            if(cpu.newHead != -1 || cpu.cx<SHORTEST_CELL_SIZE) { cpu.flag = true; return; }
            int nearAdr;
            int adr1 = findEmptyAdr(cpu.ip, cpu.cx,  1, soup);    //OT
            int adr2 = findEmptyAdr(cpu.ip, cpu.cx, -1, soup);    //T
            if (adr1 == -1) { cpu.flag = true; return; }    //ȂꍇAG[tO𗧂ĂĖ߂
            else {                                          //ꍇA߂̃AhXݒ肷
                if (regSoupAdr(adr1 - cpu.ip) > regSoupAdr(cpu.ip - adr2)) nearAdr = adr2;
                else nearAdr = adr1;
                if(canSightLength(cpu, nearAdr)) cpu.newHead = nearAdr;
                else { cpu.flag = true; return; }
            }
            cpu.ax = cpu.newHead;
            cpu.newLength = cpu.cx;
            //mۂɃxt
            for(int i = 0; i < cpu.newLength; i++) {
                this.soup[regSoupAdr(cpu.newHead + i)] = -2;
                this.authSoup[regSoupAdr(cpu.newHead + i)] = cpu.index;
            }
        }
        public void divide(Cpu cpu) { //CellƗ
            if(cpu.newHead == -1) { cpu.flag = true; return; }

            //Cell̗̈ւ̌
            for(int i = 0; i < cpu.newLength; i++) {
                authSoup[regSoupAdr(cpu.newHead + i)] = 0;
            }
            makeCell(cpu.ax, cpu.length, cpu.recordIndex);
            cpu.newHead = -1;
            cpu.divideCount++;
            if(cpu.divideCount >= 2 && !cpu.isRecord) {
                cpu.recordIndex=CellRecord.registCell(cpu, soup);
                cpu.isRecord = true;
            }
        }

        //wz̎w͈͂zƂĎ擾
        private int[] getArrayRange(int[] ary, int st, int num) {
            int[] resAry = new int[num];
            for (int i = 0; i < num; i++) resAry[i] = ary[regSoupAdr(st + i)];
            return resAry;
        }


        //PUSH
        //@w̃X^bN̍ŌɎw̒lB
        private int push(int[] stack,ref int sp, int reg) {
            if (sp >= stack.Length) return -1;
            else { stack[sp] = reg; sp++; return 1; }
        }

        //POP
        //@w̃X^bNŌ̒loB
        private int pop(int[] stack,ref int sp) {
            if (sp <= 0) return -1;
            else { sp--; return stack[sp]; }
        }

        //ev[gT
        //@wev[g(tmpl[])ɑΉev[g̃AhXAw(dir)ɒT
        //  ꍇAev[g̍ŌAhXԂ
        //@Ȃ or ev[g̏ꍇA-1Ԃ
        private int find_adr(int adr, int[] soup, int[] tmpl, int dir) {

            //ev[g(Snop_0 or nop_1)𔻒
            //ȂꍇA-1Ԃ
            foreach (int code in tmpl) {
                if (code != 0x00 && code != 0x01) return -1;
            }

            //SSoupɑ΂Aev[g
            for (int i = 0; i < SOUP_SIZE; i++) {
                if (isTmplateComplement(adr, soup, tmpl))
                    return adr + tmpl.Length - 1;
                adr = regSoupAdr(adr + dir);
            }
            return -1;
        }

        //󂫃AhXT
        //@wAhXAwʂ̃TCY󂢂Ăŋߗ̈Aw(dir)ɒT
        //  ꍇA̈̐擪AhXԂ
        //@Ȃ or ev[g̏ꍇA-1Ԃ
        private int findEmptyAdr(int adr, int size, int dir, int[] soup) {
            for (int i = 0; i < SOUP_SIZE; i++) {
                if (this.authSoup[adr] == 0) {
                    bool flag = true;
                    for (int j = 0; j < size; j++) {
                        if(this.authSoup[regSoupAdr(adr + j)] != 0) { flag = false; break; }
                    }
                    if (flag) return adr;
                }
                adr = regSoupAdr(adr + dir);
            }
            return -1;

        }

        //Iev̔
        private bool isTmplateComplement(int adr, int[] soup, int[] tmpl)
        {
            for (int i = 0; i < tmpl.Length; i++) {
                if(soup[regSoupAdr(adr + i)] != (tmpl[i] ^ 1)) return false;
            }
            return true;
        }

        //AhX̒
        //@w̃AhXsoupOȂlɒ
        //@soup̓g[X(ŌƐ擪qĂ)ł̂Ƃ
        public static int regSoupAdr(int adr) 
        {
            return (adr + SOUP_SIZE) % SOUP_SIZE;
        }


        //`悷C[W̍쐬A擾
        public Bitmap getImage(int width, int height) 
        {
            //`pobt@
            Bitmap bitmap = new Bitmap(width, height);
            int cellWidth = 1;
            int spaceWidth = 0;
            int cellHeight = 4;

            int widthNum = (int) ((width - cellWidth * 2) / (cellWidth + spaceWidth));

            //C[W̍쐬
            //gɑ΂ĕ`揈sƂŁAbitmapɃC[W쐬
            using(Graphics g = Graphics.FromImage(bitmap)) 
            {
                g.Clear(Color.Black);
                int w = 0, h = -1;
                //soupɃC[W쐬
                if(isDrawCode) for(int ip = 0; ip < SOUP_SIZE; ip++) 
                {
                    w = ip % widthNum; if(w == 0) h++;
                    Brush brush = getCodeBrush(this.soup[ip]);
                    if(brush != null) g.FillRectangle(brush, (w + 1) * (cellWidth + spaceWidth), (h + 1) * (cellHeight + 1), cellWidth, cellHeight);
                }

                if(isDrawCell) foreach(Cpu cpu in cpuGroup) 
                {
                    //eCell͂
                    if(cpu.head != -1 && cpu.length != -1) {
                        int w1 = cpu.head % widthNum;
                        int h1 = (int) (cpu.head / widthNum);
                        int w2 = (cpu.head + cpu.length - 1) % widthNum;
                        int h2 = (int) ((cpu.head + cpu.length - 1) / widthNum);
                        Rectangle rect1 = new Rectangle((w1 + 1) * (cellWidth + spaceWidth), (h1 + 1) * (cellHeight + 1), (w2 - w1 + 1) * (cellWidth + spaceWidth), (cellHeight + 1) - 2);
                        Brush brsuh =new SolidBrush(CellRecord.getColor(cpu.recordIndex));
                        if(h1 == h2) {
                            g.FillRectangle(brsuh, rect1);
                        } else {
                            Rectangle rect2 = new Rectangle((0 + 1) * (cellWidth + spaceWidth), (h2 + 1) * (cellHeight + 1), (w2 + 1) * (cellWidth + spaceWidth), (cellHeight + 1) - 2);
                            rect1.Width = width - (cellWidth + spaceWidth)-rect1.X;
                            g.FillRectangle(brsuh, rect1);
                            g.FillRectangle(brsuh, rect2);
                        }
                        g.DrawLine(Pens.DarkRed, (w1 + 1) * (cellWidth + spaceWidth), (h1 + 1) * (cellHeight + 1)-1, (w1 + 1) * (cellWidth + spaceWidth), (h1 + 2) * (cellHeight + 1) - 2);
                        g.DrawLine(Pens.DarkRed, (w2 + 1) * (cellWidth + spaceWidth), (h2 + 1) * (cellHeight + 1) - 1, (w2 + 1) * (cellWidth + spaceWidth), (h2 + 2) * (cellHeight + 1) - 2);

                    }
                }

            }
            return bitmap;
        }



        //R[hɑΉF̃uV擾
        public static Brush getCodeBrush(int code) 
        {
            Brush brush; //`ɗpuV
            switch (code) 
            {
                case 0x00: brush = Brushes.Green; break;
                case 0x01: brush = Brushes.LightGreen; break;
                case 0x02: brush = Brushes.Aqua; break;
                case 0x03: brush = Brushes.Aqua; break;
                case 0x04: brush = Brushes.Aqua; break;
                case 0x05: brush = Brushes.Aqua; break;
                case 0x06: brush = Brushes.Aqua; break;
                case 0x07: brush = Brushes.Aqua; break;
                case 0x08: brush = Brushes.Blue; break;
                case 0x09: brush = Brushes.Blue; break;
                case 0x0a: brush = Brushes.Blue; break;
                case 0x0b: brush = Brushes.LightBlue; break;
                case 0x0c: brush = Brushes.LightPink; break;
                case 0x0d: brush = Brushes.LightPink; break;
                case 0x0e: brush = Brushes.LightPink; break;
                case 0x0f: brush = Brushes.LightPink; break;
                case 0x10: brush = Brushes.Pink; break;
                case 0x11: brush = Brushes.Pink; break;
                case 0x12: brush = Brushes.Pink; break;
                case 0x13: brush = Brushes.Pink; break;
                case 0x14: brush = Brushes.DarkViolet; break;
                case 0x15: brush = Brushes.Violet; break;
                case 0x16: brush = Brushes.LightYellow; break;
                case 0x17: brush = Brushes.Yellow; break;
                case 0x18: brush = Brushes.Aqua; break;
                case 0x19: brush = Brushes.Aqua; break;
                case 0x1a: brush = Brushes.Aqua; break;
                case 0x1b: brush = Brushes.Brown; break;
                case 0x1c: brush = Brushes.Brown; break;
                case 0x1d: brush = Brushes.Orange; break;
                case 0x1e: brush = Brushes.Purple; break;
                case 0x1f: brush = Brushes.DarkRed; break;
                case -2: brush = Brushes.Gray; break;
                default: brush =null; break;
            }
            return brush;
        }

        //ߖ̎擾
        // w(code)̖ߖ擾
        private String getCodeName(int code) 
        {
            String codeStr;
            switch (code) 
            {
                case 0x00: codeStr="nop_0"; break;
                case 0x01: codeStr="nop_1"; break;
                case 0x02: codeStr="not0"; break;
                case 0x03: codeStr="sh1"; break;
                case 0x04: codeStr="zero"; break;
                case 0x05: codeStr="if_cz"; break;
                case 0x06: codeStr="sub_ab"; break;
                case 0x07: codeStr="sub_ac"; break;
                case 0x08: codeStr="inc_a"; break;
                case 0x09: codeStr="inc_b"; break;
                case 0x0a: codeStr="inc_c"; break;
                case 0x0b: codeStr="dec_c"; break;
                case 0x0c: codeStr="push_ax"; break;
                case 0x0d: codeStr="push_bx"; break;
                case 0x0e: codeStr="push_cx"; break;
                case 0x0f: codeStr="push_dx"; break;
                case 0x10: codeStr="pop_ax"; break;
                case 0x11: codeStr="pop_bx"; break;
                case 0x12: codeStr="pop_cx"; break;
                case 0x13: codeStr="pop_dx"; break;
                case 0x14: codeStr="jmp"; break;
                case 0x15: codeStr="jmpb"; break;
                case 0x16: codeStr="call"; break;
                case 0x17: codeStr="ret"; break;
                case 0x18: codeStr="mov_cd"; break;
                case 0x19: codeStr="mov_ab"; break;
                case 0x1a: codeStr="mov_abi"; break;
                case 0x1b: codeStr="adr"; break;
                case 0x1c: codeStr="adrb"; break;
                case 0x1d: codeStr="adrf"; break;
                case 0x1e: codeStr="mal"; break;
                case 0x1f: codeStr="divide"; break;
                default: codeStr = "--"; break;
            }
            return codeStr;
        }

        //Cpu擾
        public int getCpuNum() 
        {
            return cpuGroup.Count;
        }


    }

    /// <summary>
    /// [Cpu]
    /// [Tv] CellCPU
    ///         l̕ێ̂
    /// </summary>
    class Cpu 
    {
        public int ax;       //AhXpWX^
        public int bx;       //AhXpWX^
        public int cx;       //lpWX^
        public int dx;       //lpWX^
        public bool flag=false;    //G[tO
        public int ip;       //߃|C^
        public int sp;       //X^bN|C^
        public int[] stack = new int[10];   //X^bN

        //ߎsɕKvƂȂϐ
        public int head=-1; //Cell̐擪AhX
        public int length = -1; //Cell̒
        public int newLength = -1; //Cell̒
        public int newHead = -1; //Cell̐擪AhX
        public readonly int index; //Cellʔԍ
        public int recordIndex = 0; //Cellʔԍ
        public int divideCount = 0; //divide(Cell𐶂)񐔂̃JE^
        public bool isRecord = false; //divide(Cell𐶂)񐔂̃JE^


        //RXgN^
        public Cpu(int idx,int ip) 
        {
            this.ip = ip;
            this.index = idx;
        }
    }

}
